#include <iostream>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <cstdlib>
#include <linux/soundcard.h>
using namespace std;

bool readBool(string name);
int readValue(string name);

/**
 * This program plays the Audition text file format on /dev/dsp. This will
 * allow on the fly testing.
 *
 * @author Robert Flack
 */

int main()
{
	int fd;	// Sound device file descriptor
	int bitspersample;
	int frames;
	int channels;
	int samplerate;

	frames=readValue("SAMPLES");
	bitspersample=readValue("BITSPERSAMPLE");
	channels=readValue("CHANNELS");
	samplerate=readValue("SAMPLERATE");
	readBool("NORMALIZED");

	fd=open("/dev/dsp", O_RDWR);
	if (fd < 0) {
		cerr << "Error opening /dev/dsp" << endl;
		return -1;
	}
	
	if (ioctl(fd, SOUND_PCM_WRITE_BITS, &bitspersample)==-1)
	{
		cerr << "Error setting sample size on /dev/dsp" << endl;
		return -2;
	}
	
	if (ioctl(fd, SOUND_PCM_WRITE_CHANNELS, &channels)==-1)
	{
		cerr << "Error setting number of channels on /dev/dsp" << endl;
		return -2;
	}

	if (ioctl(fd, SOUND_PCM_WRITE_RATE, &samplerate)==-1)
	{
		cerr << "Error setting sample rate on /dev/dsp" << endl;
		return -2;
	}

	short *sdata = new short[2];
	for (int i=0;i<frames;i++)
	{
		for (int j=0;j<channels;j++)
		{
			cin >> sdata[j];
		}
		if (!cin.good())
		{
			cerr << "Early end of input - text file broken?" << endl;
			break;
		}
		write(fd, sdata, bitspersample/8*channels);
	}
	delete [] sdata;
	close(fd);
	return 0;
}

bool readBool(string name)
{
	string tmp;
	cin >> tmp;
	if ((name+":")!=tmp)
	{
		cerr << "Error, expected \""<<name<<"\""<<endl;
		exit(-2);
	}
	cin >> tmp;
	return (tmp=="TRUE");
}

int readValue(string name)
{
	string tmp;
	int val;
	cin >> tmp;
	if (tmp!=(name+":"))
	{
		cerr << "Error, expected "<<name<<endl;
		exit(-2);
	}
	cin >> val;
	return val;
}

